package com.winhc.fast.query.configuration;

import org.springframework.boot.actuate.health.Health;
import org.springframework.boot.actuate.health.HealthIndicator;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * @author: XuJiakai
 * 2022/6/7 10:08
 */
@Component
public class HbaseHealthIndicator implements HealthIndicator {

    private Map<String,Exception> errorMap = new HashMap<>();

    @Override
    public Health health() {
        if(errorMap.isEmpty()){
            return  Health.up()
                    .withDetail("message", "暂未发现异常！")
                    .build();
        }else{
            return Health.down()
                    .withDetail("error-info", errorMap)
                    .withDetail("message", "hbase服务异常！")
                    .build();
        }
    }

    public void putErrorInfo(Exception e){
        String name = e.getClass().getName();
        errorMap.put(name, e);
    }
}
