package com.winhc.fast.query.configuration;

import com.github.jaemon.dinger.core.entity.DingerRequest;
import com.github.jaemon.dinger.support.CustomMessage;

import java.text.MessageFormat;
import java.util.List;

/**
 * @author: XuJiakai
 * 2022/6/9 15:06
 */
public class WinhcDingTalkMessage  implements CustomMessage {

    @Override
    public String message(String projectId, DingerRequest request) {
        String content = request.getContent();
        String title = request.getTitle();
        List<String> phones = request.getPhones();
        // markdown在text内容里需要有@手机号
        StringBuilder text = new StringBuilder(title);
        if (phones != null && !phones.isEmpty()) {
            for (String phone : phones) {
                text.append("@").append(phone);
            }
        }
        return MessageFormat.format(
                "#### 【{1}】 【{0}】 \n\n{2}",
                text, projectId, content);
    }

}
