package com.winhc.fast.query.controller;

import com.winhc.fast.query.vo.ResponseVo;
import com.winhc.tool.nlp.CompanyNameAnalyzer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Mono;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author: XuJiakai
 * 2022/7/7 16:05
 */
@Slf4j
@AllArgsConstructor
@RestController
@Api(tags = "公司字号提取", value = "name_alias")
@RequestMapping("company-name-alias")
public class CompanyNameAliasController {

    private CompanyNameAnalyzer companyNameAnalyzer;


    @PostMapping()
    @ApiOperation(value = "提取")
    public Mono<ResponseVo> alias4Body(@RequestBody String[] keyword) {
        List<String> collect = Arrays.stream(keyword)
                .map(name -> companyNameAnalyzer.nameAliasExtract(name))
                .collect(Collectors.toList());
        return Mono.just(ResponseVo.success(collect));
    }

    @GetMapping()
    @ApiOperation(value = "提取")
    public Mono<ResponseVo> alias(@RequestParam String[] keyword) {
        List<String> collect = Arrays.stream(keyword)
                .map(name -> companyNameAnalyzer.nameAliasExtract(name))
                .collect(Collectors.toList());
        return Mono.just(ResponseVo.success(collect));
    }
}
